# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------
import pytest
from azure.mgmt.monitor import MonitorManagementClient

from devtools_testutils import AzureMgmtRecordedTestCase, RandomNameResourceGroupPreparer, recorded_by_proxy

AZURE_LOCATION = "eastus"


@pytest.mark.skip("you may need to update the auto-generated test case before run it")
class TestMonitorManagementSubscriptionDiagnosticSettingsOperations(AzureMgmtRecordedTestCase):
    def setup_method(self, method):
        self.client = self.create_mgmt_client(MonitorManagementClient)

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy
    def test_subscription_diagnostic_settings_get(self, resource_group):
        response = self.client.subscription_diagnostic_settings.get(
            name="str",
            api_version="2017-05-01-preview",
        )

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy
    def test_subscription_diagnostic_settings_create_or_update(self, resource_group):
        response = self.client.subscription_diagnostic_settings.create_or_update(
            name="str",
            parameters={
                "eventHubAuthorizationRuleId": "str",
                "eventHubName": "str",
                "id": "str",
                "location": "str",
                "logs": [{"enabled": bool, "category": "str"}],
                "name": "str",
                "serviceBusRuleId": "str",
                "storageAccountId": "str",
                "type": "str",
                "workspaceId": "str",
            },
            api_version="2017-05-01-preview",
        )

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy
    def test_subscription_diagnostic_settings_delete(self, resource_group):
        response = self.client.subscription_diagnostic_settings.delete(
            name="str",
            api_version="2017-05-01-preview",
        )

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy
    def test_subscription_diagnostic_settings_list(self, resource_group):
        response = self.client.subscription_diagnostic_settings.list(
            api_version="2017-05-01-preview",
        )

        # please add some check logic here by yourself
        # ...
