# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------
import pytest
from azure.mgmt.storage import StorageManagementClient

from devtools_testutils import AzureMgmtRecordedTestCase, RandomNameResourceGroupPreparer, recorded_by_proxy

AZURE_LOCATION = "eastus"


@pytest.mark.skip("you may need to update the auto-generated test case before run it")
class TestStorageManagementEncryptionScopesOperations(AzureMgmtRecordedTestCase):
    def setup_method(self, method):
        self.client = self.create_mgmt_client(StorageManagementClient)

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy
    def test_encryption_scopes_put(self, resource_group):
        response = self.client.encryption_scopes.put(
            resource_group_name=resource_group.name,
            account_name="str",
            encryption_scope_name="str",
            encryption_scope={
                "creationTime": "2020-02-20 00:00:00",
                "id": "str",
                "keyVaultProperties": {
                    "currentVersionedKeyIdentifier": "str",
                    "keyUri": "str",
                    "lastKeyRotationTimestamp": "2020-02-20 00:00:00",
                },
                "lastModifiedTime": "2020-02-20 00:00:00",
                "name": "str",
                "requireInfrastructureEncryption": bool,
                "source": "str",
                "state": "str",
                "type": "str",
            },
            api_version="2023-05-01",
        )

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy
    def test_encryption_scopes_patch(self, resource_group):
        response = self.client.encryption_scopes.patch(
            resource_group_name=resource_group.name,
            account_name="str",
            encryption_scope_name="str",
            encryption_scope={
                "creationTime": "2020-02-20 00:00:00",
                "id": "str",
                "keyVaultProperties": {
                    "currentVersionedKeyIdentifier": "str",
                    "keyUri": "str",
                    "lastKeyRotationTimestamp": "2020-02-20 00:00:00",
                },
                "lastModifiedTime": "2020-02-20 00:00:00",
                "name": "str",
                "requireInfrastructureEncryption": bool,
                "source": "str",
                "state": "str",
                "type": "str",
            },
            api_version="2023-05-01",
        )

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy
    def test_encryption_scopes_get(self, resource_group):
        response = self.client.encryption_scopes.get(
            resource_group_name=resource_group.name,
            account_name="str",
            encryption_scope_name="str",
            api_version="2023-05-01",
        )

        # please add some check logic here by yourself
        # ...

    @RandomNameResourceGroupPreparer(location=AZURE_LOCATION)
    @recorded_by_proxy
    def test_encryption_scopes_list(self, resource_group):
        response = self.client.encryption_scopes.list(
            resource_group_name=resource_group.name,
            account_name="str",
            api_version="2023-05-01",
        )
        result = [r for r in response]
        # please add some check logic here by yourself
        # ...
